# -*- coding: utf-8 -*-
import sys
import pygtk
if sys.platform != 'win32':
    pygtk.require('2.0')
import gtk


#
#
class ReplacePathDialog:
    '''
    ファイルパス中の文字列置換指定用ダイアログ
    '''
    def __init__(self, parent=None):
        '''
        初期化
        '''
        self.dlg = gtk.Dialog('Replace file path',
                               parent,
                               gtk.DIALOG_MODAL,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OK, gtk.RESPONSE_OK))
        self.dlg.set_border_width(5)
        self.dlg.set_size_request(350, -1)
        self.dlg.set_position(gtk.WIN_POS_CENTER)

        widget = self.construct_contents()
        if widget:
            self.dlg.vbox.pack_start(widget)

        self.dlg.show_all()

    def construct_contents(self):
        '''
        ダイアログの表示内容を構築
        '''
        vbox = gtk.VBox()
        # 検索文字列設定用
        hbox = gtk.HBox()
        label = gtk.Label('Search :')
        label.set_size_request(60, -1)
        hbox.pack_start(label, False, False, 4)

        self.S_Entry = gtk.Entry()
        hbox.pack_end(self.S_Entry, True, True, 4)
        vbox.pack_start(hbox, False, False, 5)
        
        # 置換文字列設定用
        hbox = gtk.HBox()
        label = gtk.Label('Replace :')
        label.set_size_request(60, -1)
        hbox.pack_start(label, False, False, 4)

        self.R_Entry = gtk.Entry()
        hbox.pack_end(self.R_Entry, True, True, 4)
        vbox.pack_start(hbox, False, False, 5)

        # Src/Dst切替用ラジオボタン
        # src
        hbox = gtk.HBox()
        self.S_Radio = gtk.RadioButton(None, 'Source path')
        hbox.pack_start(self.S_Radio, False, False, 4)

        # dst
        self.D_Radio = gtk.RadioButton(self.S_Radio, 'Destination path')
        hbox.pack_start(self.D_Radio, False, False, 4)        

        # Both
        self.B_Radio = gtk.RadioButton(self.S_Radio, 'Both')
        hbox.pack_start(self.B_Radio, False, False, 4)

        frame = gtk.Frame('Select target')
        frame.set_size_request(-1, 40)
        frame.add(hbox)
        vbox.pack_start(frame, False, False, 5)
        
        return vbox

    def run(self):
        '''
        ダイアログのイベントループを開始
        '''
        return self.dlg.run()

    def destroy(self):
        '''
        ダイアログの破棄
        '''
        self.dlg.destroy()

    def get_text_for_search(self):
        '''
        検索文字列を取得
        '''
        return self.S_Entry.get_text()

    def get_text_for_replace(self):
        '''
        置換文字列を取得
        '''
        return self.R_Entry.get_text()

    def get_target(self):
        '''
        ターゲットを取得。
        置き換え対象がコピー元の場合には文字列："SRC"
        置き換え対象がコピー先の場合には文字列："DST"
        '''        
        if self.S_Radio.get_active():
            return 'SRC'
        elif self.D_Radio.get_active():
            return 'DST'
        elif self.B_Radio.get_active():
            return 'BOTH'
        return None

#
#
if __name__ == '__main__':
    dlg = ReplacePathDialog()
    response = dlg.run()
    dlg.destroy()
