# -*- coding: utf-8 -*-

import os.path


#
#
class FCPLogMgr:
    '''
    ログ管理を行うクラス
    '''
    def __init__(self):
        '''
        初期化
        '''
        # ログ保持用のリストを初期化
        self.logs = []

    def push(self, item):
        '''
        ログを登録する。
        '''
        if self.logs == None:
            return
        if item == None:
            return
        self.logs.append(item)

    def get_logs(self):
        '''
        登録されている全てのログをタプルとして返す。
        '''
        return tuple(self.logs)
    
    def clear(self):
        '''
        保持している情報を全て破棄する。
        '''
        del self.logs[:]

    def save(self, path, writeMode='w'):
        '''
        ログを指定されたパスのファイルとして出力する。
        '''
        if self.logs == None:
            return
        if path == None or len(path) == 0:
            return
        if writeMode == None or len(writeMode) == 0:
            writeMode = 'w'

        # ログパス文字列を絶対パスに変換
        logPath = os.path.normpath(os.path.expanduser(path))
        logPath = os.path.abspath(logPath)

        try:
            # ログファイルを書き込みモードで開く
            f = file(logPath, writeMode)
            
            # ログをテキストにまとめる
            text = ''
            for log in self.logs:
                errno, errstr, src, dst = log
                msgLine = 'error(%d) %s %s --> %s\n' % (errno,
                                                        errstr.encode('utf-8'),
                                                        src,
                                                        dst)
                text += msgLine
            text += '----\n'
            # ログのテキストを一括で書き込んでファイルを閉じる。
            f.write(text)
            f.close()
        except:
            print 'Can not export error log file.'
