# -*- coding: utf-8 -*-

import sys
import pygtk

if sys.platform != 'win32':
    pygtk.require('2.0')
import gtk

HEIGHT_STATUS_BAR = 16

#
#
class StatusView(gtk.Statusbar):
    '''
    ステータスバークラス。
    コピー中のファイル名、およびコピー状況を示すためのプログレスバー
    を表示するクラス。
    '''
    def __init__(self):
        '''
        初期化
        '''
        gtk.Statusbar.__init__(self)

        self.progressRange = 0
        self.progressValue = 0
        self.contextId = 0
        self.progressBox = gtk.HBox(False)        
        self.progressBox.set_size_request(60, HEIGHT_STATUS_BAR)
        self.pack_start(self.progressBox, False, False, 2)

        self.progressBar = gtk.ProgressBar()
        self.progressBar.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
        self.progressBox.pack_start(self.progressBar)
        
        self.set_size_request(-1, HEIGHT_STATUS_BAR)

    def set_progress_range(self, value):
        '''
        プログレスバーの値範囲（valueは最大値)を指定
        '''
        self.progressRange = value

    def set_status_text(self, text):
        '''
        プログレスバーのステータス行へテキストを設定する。
        '''
        self.contextId = self.push(self.contextId, text)
    
    def set_fraction(self, value):
        '''
        プログレスバーの現在の値を設定する。
        １〜
        '''
        if self.progressRange < 1:
            return
        
        gtk.gdk.threads_enter()

        self.progressValue = value
        frac = float(self.progressValue) / float(self.progressRange)
        self.progressBar.set_fraction(frac)
        self.progressBar.set_text('%d/%d' % (self.progressValue,
                                             self.progressRange))
        gtk.gdk.threads_leave()

    def clear_progress_text(self):
        '''
        プログレスバーのテキスト表示をクリアする
        '''
        self.progressBar.set_text('')
        
    def increment(self):
        '''
        プログレスバーの値を増加(+1)する。
        '''        
        self.set_fraction(self.progressValue + 1)
